/*
 * File: Constant.java
 * -------------------
 * This file defines the expression subclass consisting
 * of an integer constant.
 */

import java.io.*;

/* Class: Constant */
/**
 * This expression subclass represents an integer
 * constant.
 */
public class Constant extends Expression {

/* Constructor: Constant(value) */
/**
 * Creates a constant expression with the specified value.
 */
	public Constant(int value) {
		this.value = value;
	}

/* Method: eval() */
/**
 * Evaluates an expression to return an integer.  For
 * the Constant class, the result is simply the value.
 */
	public int eval() {
		return value;
	}

/* Method: unparse(wr) */
/**
 * Writes out a human-readable version of the expression
 * to the specified PrintWriter.  For a Constant, this
 * representation is simply the value.
 */
	public void unparse(PrintWriter wr) {
		wr.print(value);
	}

/* Private state */
	private int value;

}
