/*
 * File: TestBST.java
 * ------------------
 * This file contains a main program to test the operation of a
 * binary search tree.
 */

import acm.program.*;

public class TestBST extends ConsoleProgram {

/* Standard entry point */
	public static void main(String[] args) {
		new TestBST().start(args);
	}

/* Program entry point */
	public void run() {
		BSTMap bst = new BSTMap();
		while (true) {
			print("> ");
			String line = readLine();
			if (line.equals("quit") || line.equals("")) {
				break;
			} else if (line.equals("list")) {
				bst.listBindings(getWriter());
			} else if (line.equals("print")) {
				bst.listBindings(System.out);
			} else {
				int eq = line.indexOf("=");
				if (eq == -1) {
					String key = line.trim();
					if (key.length() > 0) {
						println(bst.get(key));
					}
				} else {
					String key = line.substring(0, eq).trim();
					String value = line.substring(eq + 1).trim();
					bst.put(key, value);
				}
			}
		}
	}
}
