/*
 * File: TestExp.java
 * ------------------
 * This file tests the expression tree package by parsing,
 * unparsing, and evaluating expressions typed by the user.
 */

import acm.program.*;

public class TestExp extends ConsoleProgram {

/* Standard entry point */
	public static void main(String[] args) {
		new TestExp().start(args);
	}

/* Program entry point */
	public void run() {
		Parser parser = new Parser();
		while (true) {
			print("> ");
			String line = readLine();
			if (line.equals("")) {
				break;
			} else {
				parser.setInput(line);
				Expression exp = parser.readExpression();
				print("Unparsed version: ");
				exp.unparse(getWriter());
				println();
				println("Value: " + exp.eval());
			}
		}
	}
}
