/*
 * File: Variable.java
 * -------------------
 * This file defines the expression subclass consisting
 * of an integer constant.
 */

import java.io.*;

/* Class: Variable */
/**
 * This expression subclass represents a variable.
 */
public class Variable extends Expression {

/* Constructor: Variable(value) */
/**
 * Creates a constant expression with the specified value.
 */
	public Variable(String name) {
		this.name = name;
	}

/* Method: eval() */
/**
 * Evaluates an expression to return an integer.  For
 * the Variable class, the result is the stored value.
 */
	public int eval() {
		return value;
	}

/* Method: unparse(wr) */
/**
 * Writes out a human-readable version of the expression
 * to the specified PrintWriter.  For a Variable, this
 * representation is simply the name.
 */
	public void unparse(PrintWriter wr) {
		wr.print(name);
	}

/* Method: assignValue(value) */
/**
 * Assigns a new value to a variable.
 */
	public void assignValue(int value) {
		this.value = value;
	}

/* Private state */
	private String name;
	private int value;

}
